import { defineComponent as z, computed as G, ref as w, watch as _, shallowRef as D, onMounted as H, createVNode as r, resolveComponent as O, mergeProps as p, toRef as K, unref as S, Fragment as x, nextTick as L, isVNode as J } from "vue";
import { formProps as Q, formEmits as W } from "./props.js";
import { dialogProps as X, dialogEmits as Y, ElFormItem as F, ElCol as U } from "element-plus";
import { pickObjByKeys as v, firstUppercase as Z, deepClone as ee, omitObjByKeys as oe } from "@tomiaa/utils";
import { KCustomElement as m } from "../../customElement/index.js";
import "@wangeditor/editor/dist/css/style.css";
function le(l) {
  return typeof l == "function" || Object.prototype.toString.call(l) === "[object Object]" && !J(l);
}
const ue = z({
  name: "KForm",
  props: Q,
  emits: W,
  setup(l, {
    attrs: g,
    slots: c,
    emit: i,
    expose: B
  }) {
    const y = l.modelValue !== void 0, j = ["", !1].includes(g.inline), I = G(() => v(l, Object.keys(X))), k = {};
    for (const e in Y)
      k["on" + Z(e)] = (...o) => i(e, ...o);
    const u = w(), N = () => r(O("el-dialog"), p({
      ref: u
    }, k, {
      onClosed: () => {
        var e;
        !l.destroyOnClose || (b(), (e = s.value) == null || e.resetFields());
      }
    }, I.value), {
      footer: l.showActions ? R : void 0,
      ...c,
      default: A
    }), R = () => {
      var o, a, t, V;
      let e = [{
        el: "el-button",
        type: "primary",
        "v-if": l.actionsConfig.showSubmit,
        onClick() {
          var P, T;
          const f = {
            formRef: s,
            dialogRef: u,
            formModel: n,
            validate: (P = s.value) == null ? void 0 : P.validate,
            rawFormModel: h()
          };
          if (l.autoValidateOnSubmit) {
            (T = s.value) == null || T.validate((q) => {
              i(q ? "submit" : "submitCheckFail", f);
            });
            return;
          }
          i("submit", f);
        },
        children: (o = l.actionsConfig.submitText) != null ? o : "\u63D0\u4EA4"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showReset,
        onClick() {
          var f;
          s.value.resetFields(), i("reset", {
            formRef: s,
            dialogRef: u,
            formModel: n,
            validate: (f = s.value) == null ? void 0 : f.validate,
            rawFormModel: h()
          });
        },
        children: (a = l.actionsConfig.resetText) != null ? a : "\u91CD\u7F6E"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showCancel,
        onClick() {
          i("update:modelValue", !1), i("cancel");
        },
        children: (t = l.actionsConfig.cancelText) != null ? t : "\u53D6\u6D88"
      }];
      return (V = l.actionsConfig) != null && V.custom && (e = l.actionsConfig.custom(e)), y ? r(m, {
        list: e
      }, null) : j ? r(F, null, {
        default: () => [r(m, {
          list: e
        }, null)]
      }) : r(U, l.actionsConfig, {
        default: () => [r(F, null, {
          default: () => [r(m, {
            list: e
          }, null)]
        })]
      });
    }, s = w(), n = w(l.model);
    _(n, (e) => {
      i("update:model", e);
    });
    const b = () => {
      n.value = l.model, l.options.forEach((e) => {
        if (e.prop && typeof e.prop == "string") {
          const o = e.el === "el-upload" ? "fileList" : "modelValue";
          n.value[e.prop] = K(e, o);
        }
      });
    };
    b();
    const h = () => {
      const e = {};
      for (const o in n.value)
        e[o] = S(n.value[o]);
      return e;
    }, A = () => r(O("el-form"), p(g, {
      ref: s,
      model: n.value
    }), {
      default: () => [r(O("el-row"), g, {
        default: () => [E(l.options), l.showActions && !y && R()]
      })]
    }), E = (e) => e.map((o) => {
      if (o = S(o), Array.isArray(o))
        return E(o);
      o.el === "el-upload" && (o.fileList = n.value[o.prop], o["onUpdate:fileList"] = (t) => {
        Object.prototype.hasOwnProperty.call(n.value, o.prop) && (n.value[o.prop] = t);
      });
      let a = {
        ...v(o, Object.keys(U.props)),
        class: o.class ? `${o.class}__el-col` : "",
        el: "el-col",
        children: {
          ...v(o, Object.keys(F.props)),
          class: o.class ? `${o.class}__el-form-item` : "",
          el: "el-form-item",
          children: o
        }
      };
      return j && (a = a.children), o.el === "editor" && (a.children.children = $(o)), r(m, {
        model: n.value,
        list: a
      }, le(c) ? c : {
        default: () => [c]
      });
    }), d = D({}), $ = async (e) => {
      if (e.prop && !d.value[e.prop] && (d.value[e.prop] = D()), typeof window > "u")
        return r(x, null, null);
      const {
        Toolbar: o,
        Editor: a
      } = await import("@wangeditor/editor-for-vue");
      return r(x, null, [r(o, p({
        style: "border-bottom: 1px solid #ccc",
        mode: "default",
        editor: e.prop && d.value[e.prop].value
      }, e.editorAttrs), null), r(a, p({
        style: "height: 300px; width: 100%; overflow-y: hidden",
        mode: "default",
        modelValue: n.value[e.prop],
        "onUpdate:model-value": (t) => {
          Object.prototype.hasOwnProperty.call(n.value, e.prop) && (n.value[e.prop] = t);
        },
        onOnCreated: (t) => {
          !e.prop || (d.value[e.prop].value = t, typeof e.ref == "function" ? e.ref(t) : K(e, "ref").value = t);
        }
      }, e.toolbarAttrs), null)]);
    }, C = {
      initFormModel: b,
      getRawFormModel: h,
      setFormModel: async (e, {
        includes: o = [...l.options.map((t) => t.prop).filter((t) => t), "id"],
        exclude: a = []
      } = {}) => {
        e = ee(e);
        let t = o != null && o.length ? v(e, o) : e;
        a != null && a.length && (t = oe(t, a)), await L(), Object.assign(n.value, t);
      },
      getFormRef: () => s,
      getDialogRef: () => u,
      formModel: n
    }, M = async () => {
      await L(), Object.assign(C, s.value), Object.assign(C, u.value);
    };
    return H(M), _(() => l.modelValue, M), B(C), () => r("div", null, [y ? N() : A()]);
  }
});
export {
  ue as default
};
